package higa.dbswing;

import com.sun.java.swing.AbstractListModel;

import java.sql.Statement;
import java.sql.ResultSet;

import java.util.Vector;

import java.io.Serializable;

import higa.sql.dataset.IDataSet;
import higa.sql.dataset.Column;
import higa.sql.dataset.HDatabase;

public class HListModel extends AbstractListModel
  implements Serializable {

  private Vector values = new Vector();
  private Vector displays = new Vector();

  public HListModel() {
  }

  public HListModel(IDataSet dataSet,
    String columnName,
    String pickListTableName, String pickListColumnName,
    String pickListDisplayColumnName) {

    if (pickListTableName == null) {
      if (dataSet != null) {
        Column column = dataSet.getColumn(columnName);
        pickListTableName = column.getPickListTableName();
      }
    }

    if (pickListColumnName == null) {
      if (dataSet != null) {
        Column column = dataSet.getColumn(columnName);
        pickListColumnName = column.getPickListColumnName();
      }
    }

    if (pickListDisplayColumnName == null) {
      if (dataSet != null) {
        Column column = dataSet.getColumn(columnName);
        pickListDisplayColumnName =
          column.getPickListDisplayColumnName();
      }
    }

    if (pickListTableName == null ||
      pickListColumnName == null ||
      pickListDisplayColumnName == null ||
      dataSet == null) {

      return;
    }

    HDatabase db = dataSet.getDatabase();
    if (db == null) {
      return;
    }

    try {
      String query = "SELECT " +
        pickListDisplayColumnName +
        "," + pickListColumnName +
        " FROM " + pickListTableName;

      Statement stmt = db.createStatement();
      ResultSet rs = stmt.executeQuery(query);
      while (rs.next()) {
        String display = rs.getString(1);
        String value = rs.getString(2);
        displays.addElement(display);
        values.addElement(value);
      }

      Column column = dataSet.getColumn(columnName);
      if (column.isNullable()) {
        //displays.addElement(String.valueOf((Object)null));
        displays.addElement(null);
        values.addElement(null);
      }

      rs.close();
      stmt.close();
    } catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public Object getElementAt(int index) {
    return displays.elementAt(index);
  }

  public int getElementIndex(Object display) {
    int index = display != null ?
      displays.indexOf(display) : -1;

    return index >= 0 ? index : getSize() - 1;
  }

  public Object getValueAt(int index) {
    return values.elementAt(index);
  }

  public int getValueIndex(Object value) {
    int index = value != null ?
      values.indexOf(value) : -1;
      
    return index >= 0 ? index : getSize() - 1;
  }

  public int getSize() {
    return displays.size();
  }
}