package higa.jhcl.view;

import java.io.Serializable;

import higa.jhcl.model.BasicVectorContainer;

public class RowViewManager
  extends BasicVectorContainer
  implements SizeVector, Serializable {

  private int defaultRowHeight = 20;
  private GridCore grid;

  public RowViewManager(GridCore grid) {
    this.grid = grid;
  }

  public Object get(int index) {
    int count = super.getCount();
    return count == 0 ? Integer.toString(index) :
      super.get(index);
  }

  public void setDefaultRowHeight(int height) {
    if (height < 0) {
      throw new IllegalArgumentException(
        "height:" + height);
    }

    defaultRowHeight = height;
  }

  public int getDefaultRowHeight() {
    return defaultRowHeight;
  }

  public int find(Object data) {
    return -1;
  }

  public int getCount() {
    int count = super.getCount();
    return count == 0 ? grid.getRowCount() : count;
  }

  public void setSize(int index, int size) {
    setDefaultRowHeight(size);
  }

  public int getSize(int index) {
    return getDefaultRowHeight();
  }

  public int getSizeUpTo(int index) {
    int last = Math.min(index, getCount());
    return defaultRowHeight * last;
  }
}