package higa.jsqlplus;

import java.awt.Label;
import java.awt.TextField;
import java.awt.Button;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import higa.util.Resources;
import higa.util.BaseDialog;

public class ConnectDialog extends BaseDialog
  implements ActionListener {

  private static final Resources resources =
    new Resources("higa.jsqlplus.resources.dialog");

  private static final String DRIVER =
    resources.getString("driver");

  private static final String CONNECTION_URL =
    resources.getString("connectionURL");

  private static final String USERNAME =
    resources.getString("username");

  private static final String PASSWORD =
    resources.getString("password");

  private static final String OK =
    resources.getString("ok");

  private static final String CANCEL =
    resources.getString("cancel");

  private Label driverLabel =
    new Label(DRIVER);

  private Label connectionURLLabel =
    new Label(CONNECTION_URL);

  private Label userNameLabel =
    new Label(USERNAME);

  private Label passwordLabel =
    new Label(PASSWORD);

  private TextField driverTextField =
    new TextField(DRIVER);

  private TextField connectionURLTextField =
    new TextField(CONNECTION_URL);

  private TextField userNameTextField =
    new TextField(USERNAME);

  private TextField passwordTextField =
    new TextField(PASSWORD);

  private Button okButton = new Button(OK);
  private Button cancelButton = new Button(CANCEL);

  private boolean ok;

  private GridLayout layout = new GridLayout(5, 2, 2, 2);

  public ConnectDialog(String driver, String connectionURL,
    String userName, String password) {
    driverTextField.setText(driver);
    connectionURLTextField.setText(connectionURL);
    userNameTextField.setText(userName);
    passwordTextField.setText(password);
    passwordTextField.setEchoChar('*');
    try {
      jbInit();
    } catch (Exception ex) {
      ex.printStackTrace();
    }
    
    pack();
  }

  public void setDriver(String driver) {
    driverTextField.setText(driver);
  }

  public String getDriver() {
    return driverTextField.getText();
  }

  public void setConnectionURL(String connectionURL) {
    connectionURLTextField.setText(connectionURL);
  }

  public String getConnectionURL() {
    return connectionURLTextField.getText();
  }

  public void setUserName(String userName) {
    userNameTextField.setText(userName);
  }

  public String getUserName() {
    return userNameTextField.getText();
  }

  public void setPassword(String password) {
    passwordTextField.setText(password);
  }

  public String getPassword() {
    return passwordTextField.getText();
  }

  public boolean isOK() {
    return ok;
  }

  public void actionPerformed(ActionEvent evt) {
    if (okButton == (Button)evt.getSource()) {
      ok = true;
    }
    dispose();
  }

  public void setVisible(boolean visible) {
    if (visible) {
      userNameTextField.requestFocus();
    }
    ok = false;
    super.setVisible(visible);
  }

  private void jbInit() throws Exception {
    setLayout(layout);
    add(userNameLabel);
    add(userNameTextField);
    add(passwordLabel);
    add(passwordTextField);
    add(connectionURLLabel);
    add(connectionURLTextField);
    add(driverLabel);
    add(driverTextField);
    add(okButton);
    add(cancelButton);
    okButton.addActionListener(this);
    cancelButton.addActionListener(this);
  }
}