package higa.sql.dataset;

import java.io.Serializable;

import java.text.Format;

public class Column implements PickListAware, Serializable {

  private String name;
  private String caption;
  private int type;
  private boolean nullable;
  private int displaySize;
  private Format formatter;
  private String pickListTableName;
  private String pickListColumnName;
  private String pickListDisplayColumnName;

  public Column() {}

  public Column(String name, String caption,
    int type, boolean nullable, int displaySize) {

    this.name = name;
    this.caption = caption;
    this.type = type;
    this.nullable = nullable;
    this.displaySize = displaySize;
  }

  public Column(Column column) {
    this(column.name, column.caption, column.type,
      column.nullable, column.displaySize);

    formatter = column.formatter;
    pickListTableName = column.pickListTableName;
    pickListColumnName = column.pickListColumnName;
    pickListDisplayColumnName = column.pickListDisplayColumnName;
  }

  public String getName() {
    return name;
  }

  public void setCaption(String caption) {
    this.caption = caption;
  }

  public String getCaption() {
    return caption;
  }

  public void setType(int type) {
    this.type = type;
  }

  public int getType() {
    return type;
  }

  public void setNullable(boolean nullable) {
    this.nullable = nullable;
  }

  public boolean isNullable() {
    return nullable;
  }

  public void setDisplaySize(int displaySize) {
    this.displaySize = displaySize;
  }

  public int getDisplaySize() {
    return displaySize;
  }

  public void setFormatter(Format formatter) {
    this.formatter = formatter;
  }

  public Format getFormatter() {
    return formatter;
  }

  public void setPickList(String tableName,
    String columnName, String displayColumnName) {

    pickListTableName = tableName;
    pickListColumnName = columnName;
    pickListDisplayColumnName = displayColumnName;
  }

  public void setPickListTableName(String s) {
    pickListTableName = s;
  }

  public String getPickListTableName() {
    return pickListTableName;
  }

  public void setPickListColumnName(String s) {
    pickListColumnName = s;
  }

  public String getPickListColumnName() {
    return pickListColumnName;
  }

  public void setPickListDisplayColumnName(String s) {
    pickListDisplayColumnName = s;
  }

  public String getPickListDisplayColumnName() {
    return pickListDisplayColumnName;
  }

  public String toString() {
    return "name:" + name + "\t" +
      "caption:" + caption + "\t" +
      "type:" + type + "\t" +
      "nullable:" + nullable + "\t" +
      "displaySize:" + displaySize + "\t" +
      "pickListTableName:" + pickListTableName + "\t" +
      "pickListColumnName:" + pickListColumnName + "\t" +
      "pickListDisplayColumnName:" + pickListDisplayColumnName;
  }
}