package higa.util;

import java.text.Format;
import java.text.SimpleDateFormat;
import java.text.DecimalFormat;

public class Formatter {

  public static final String format(
    Format formatter, Object value) {

    String result = "";

    if (value != null) {
      if (null == formatter) {
        if (value instanceof byte[]) {
          result = new String((byte[])value);
        } else {
          result = value.toString();
        }
      } else {
        try {
          result = formatter.format(value);
        } catch (IllegalArgumentException ex) {
          result = value.toString();
        }
      }
    }

    return result;
  }

  public static final Object parseObject(
    Format formatter, Object value) {

    Object newValue = new Object();
    newValue = value;

    if (formatter != null &&
      value instanceof String) {

      String s = value.toString();
      try {
        newValue = formatter.parseObject(s);
      } catch (Exception ex) {}
    }

    return newValue;
  }

  public static final Format getDefaultFormatter(
    int type, String pattern) {
    Format formatter = null;

    if (pattern != null &&
      pattern.length() != 0) {

      if (JDBCUtil.isDate(type)) {
        formatter = new SimpleDateFormat(pattern);
      } else if (JDBCUtil.isNumber(type)) {
        formatter = new DecimalFormat(pattern);
      }
    }

    return formatter;
  }

  private Formatter() {}
} 