package higa.util;

import java.awt.TextArea;
import java.awt.BorderLayout;

public class TextDialog extends BaseDialog {

  private TextArea textArea = new TextArea();

  public TextDialog() {
    this(true);
  }

  public TextDialog(boolean modal) {
    super(modal);
    add(textArea, BorderLayout.CENTER);
    pack();
  }

  public TextDialog(String s) {
    this();
    setText(s);
  }

  public void setText(String text) {
    textArea.setText(text);
  }

  public String getText() {
    return textArea.getText();
  }

  public void setEditable(boolean editable) {
    textArea.setEditable(editable);
  }

  public boolean isEditable() {
    return textArea.isEditable();
  }

  public void setVisible(boolean visible) {
    super.setVisible(visible);
    if (textArea.isEditable()) {
      textArea.requestFocus();
    }
  }
}